unit Labyrinth;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Printers, Buttons;

 CONST MAXZ=200;MAXS=250;Delta=15;
 TYPE IRR=ARRAY[1..MAXZ,1..MAXS]OF BYTE;

type
  TIrrgarten = class(TForm)
    EditLaenge: TSpinEdit;
    LabelLaenge: TLabel;
    EditBreite: TSpinEdit;
    LabelBreite: TLabel;
    Baue: TButton;
    EditGang: TSpinEdit;
    Labelgang: TLabel;
    EingangWahl: TRadioGroup;
    AusgangWahl: TRadioGroup;
    Bild: TImage;
    Wegsuche: TButton;
    Drucken: TButton;
    PrintDialog: TPrintDialog;
    Menschsuche: TButton;
    ButtonHoch: TBitBtn;
    ButtonRechts: TBitBtn;
    ButtonUnten: TBitBtn;
    ButtonLinks: TBitBtn;
    EditRi: TEdit;
    procedure BaueClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    PROCEDURE BILDSCHIRM(L:IRR;LL,LB,A:INTEGER);
    Procedure Line(X1,Y1,X2,Y2:Integer);
    procedure EditGangChange(Sender: TObject);
    PROCEDURE ERZEUGE(VAR L:IRR;LL,LB,A:INTEGER);
    procedure WegsucheClick(Sender: TObject);
    PROCEDURE WEGSUCHEN(LA:IRR;LL,LB,G:INTEGER);
    procedure DruckenClick(Sender: TObject);
    procedure MenschsucheClick(Sender: TObject);
    procedure ButtonWahl(Sender: TObject);
    procedure EditRiKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
   XSuch,YSuch,XPos,YPos:Integer;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Irrgarten: TIrrgarten;

implementation

{$R *.DFM}
{$R+,Q+} 
 VAR LABY:IRR;
     XEINGANG,XAUSGANG,YEINGANG,YAUSGANG,SUCHRICHTUNG,
     MAXX,MAXY,LAENGE,BREITE,GROESSE:INTEGER;

 PROCEDURE TIrrgarten.ERZEUGE(VAR L:IRR;LL,LB,A:INTEGER);
  VAR SR,ZR,P:ARRAY[0..3]OF INTEGER;
      T:ARRAY[1..4]OF BYTE;
      RA,Z,S,RZ,Q,R,RI,NEU:INTEGER;
  BEGIN
   P[0]:=1;P[1]:=2;P[2]:=4;P[3]:=8;
   ZR[0]:=-1;ZR[1]:=0;ZR[2]:=1;ZR[3]:=0;
   SR[0]:=0;SR[1]:=1;SR[2]:=0;SR[3]:=-1;
   FOR Z:=1 TO LL DO
    FOR S:=1 TO LB DO L[Z,S]:=0;
   RA:=LL*LB;Z:=RANDOM(LL)+1;S:=RANDOM(LB)+1;
   FOR RZ:=2 TO RA DO
    BEGIN
     REPEAT
      Q:=0;
      IF Z>1  THEN IF L[Z-1,S]=0 THEN BEGIN INC(Q);T[Q]:=0 END;
      IF S<LB THEN IF L[Z,S+1]=0 THEN BEGIN INC(Q);T[Q]:=1 END;
      IF Z<LL THEN IF L[Z+1,S]=0 THEN BEGIN INC(Q);T[Q]:=2 END;
      IF S>1  THEN IF L[Z,S-1]=0 THEN BEGIN INC(Q);T[Q]:=3 END;
      IF Q=0 THEN
       REPEAT
        INC(Z);
        IF Z>LL THEN BEGIN Z:=1;INC(S);IF S>LB THEN S:=1 END
       UNTIL L[Z,S]<>0
     UNTIL Q<>0;
     R:=RANDOM(Q)+1;RI:=T[R];
     L[Z,S]:=L[Z,S]+P[RI];S:=S+SR[RI];Z:=Z+ZR[RI];
     NEU:=RI-2;IF NEU<0 THEN NEU:=NEU+4;
     L[Z,S]:=L[Z,S]+P[NEU]
    END;{ OF FOR }
   Case EingangWahl.ItemIndex of
     0 : Begin // Oben
          XEINGANG:=RANDOM(LB)+1;YEINGANG:=1;
          SUCHRICHTUNG:=4;
          L[1,XEINGANG]:=L[1,XEINGANG]+1;
         End;
     1 : Begin // Rechts
          YEINGANG:=RANDOM(LL)+1;XEINGANG:=LB;
          SUCHRICHTUNG:=8;
          L[YEINGANG,LB]:=L[YEINGANG,LB]+2;
         End;
     2 : Begin // Unten
          XEINGANG:=RANDOM(LB)+1;YEINGANG:=LL;
          SUCHRICHTUNG:=1;
          L[LL,XEINGANG]:=L[LL,XEINGANG]+4;
         End;
     3 : Begin // Links
          YEINGANG:=RANDOM(LL)+1;XEINGANG:=1;
          SUCHRICHTUNG:=2;
          L[YEINGANG,1]:=L[YEINGANG,1]+8;
         End;
    End;
   Case AusgangWahl.ItemIndex of
     0 : Begin // Oben
          XAUSGANG:=RANDOM(LB)+1;YAUSGANG:=1;
          L[1,XAUSGANG]:=L[1,XAUSGANG]+1;
         End;
     1 : Begin // Rechts
          YAUSGANG:=RANDOM(LL)+1;XAUSGANG:=LB;
          L[YAUSGANG,LB]:=L[YAUSGANG,LB]+2;
         End;
     2 : Begin // Unten
          XAUSGANG:=RANDOM(LB)+1;YAUSGANG:=LL;
          L[LL,XAUSGANG]:=L[LL,XAUSGANG]+4;
         End;
     3 : Begin // Links
          YAUSGANG:=RANDOM(LL)+1;XAUSGANG:=1;
          L[YAUSGANG,1]:=L[YAUSGANG,1]+8;
         End;
    End;
  END;{ OF ERZEUGE }

 Procedure TIrrgarten.Line(X1,Y1,X2,Y2:Integer);
  Begin
   With Bild.Canvas do
    Begin
     MoveTo(X1,Y1);LineTo(X2,Y2);
    End
  End;

 PROCEDURE TIrrgarten.BILDSCHIRM(L:IRR;LL,LB,A:INTEGER);
  VAR S,Z:INTEGER;
  BEGIN
   Bild.Canvas.Pen.Color:=clGreen;
   FOR S:=1 TO LB DO
    if not Odd(L[1,S]) then LINE(A*(S-1)+Delta,0+Delta,A*S+Delta,0+Delta);
   FOR Z:=1 TO LL DO
    BEGIN
     if L[Z,1]<8 then LINE(0+Delta,A*(Z-1)+Delta,0+Delta,A*Z+Delta);
     FOR S:=1 TO LB DO
      BEGIN
       IF L[Z,S] IN[0,1,8,9] THEN
        BEGIN
         LINE(A*S+Delta,A*Z+Delta,A*S+Delta,A*(Z-1)+Delta);
         LINE(A*S+Delta,A*Z+Delta,A*(S-1)+Delta,A*Z+Delta)
        END;
       IF L[Z,S] IN[4,5,12,13] THEN
        LINE(A*S+Delta,A*Z+Delta,A*S+Delta,A*(Z-1)+Delta);
       IF L[Z,S] IN[2,3,10,11] THEN
        LINE(A*S+Delta,A*Z+Delta,A*(S-1)+Delta,A*Z+Delta)
      END
    END
  END;{ OF BILDSCHIRM }

 procedure TIrrgarten.BaueClick(Sender: TObject);
  Var Rect:TRect;
  begin
   Bild.Canvas.Brush.Color:=clWhite;// Hintergrundfarbe
   Rect.Left:=0;Rect.Top:=0;
   Rect.Right:=Bild.Width;Rect.Bottom:=Bild.Height;
   Bild.Canvas.FillRect(Rect);// Formular fllen
   Groesse:=EditGang.Value;
   Laenge:=EditLaenge.Value;
   Breite:=EditBreite.Value;
   ERZEUGE(LABY,LAENGE,BREITE,GROESSE);
   BILDSCHIRM(LABY,LAENGE,BREITE,GROESSE);
   ButtonHoch.Visible:=False;ButtonRechts.Visible:=False;
   ButtonUnten.Visible:=False;ButtonLinks.Visible:=False;
   Wegsuche.Enabled:=True;Drucken.Enabled:=True;Menschsuche.Enabled:=True;
  end;

 procedure TIrrgarten.FormCreate(Sender: TObject);
  begin
   MaxX:=Bild.Width-3*Delta;MaxY:=Bild.Height-3*Delta;
   EditLaenge.MaxValue:=MaxY Div EditGang.Value;
   EditBreite.MaxValue:=MaxX Div EditGang.Value;
   Wegsuche.Enabled:=False;Drucken.Enabled:=False;
   Menschsuche.Enabled:=False;Randomize;
   ButtonHoch.Visible:=False;ButtonRechts.Visible:=False;
   ButtonUnten.Visible:=False;ButtonLinks.Visible:=False;
  end;

 procedure TIrrgarten.EditGangChange(Sender: TObject);
  begin
   EditLaenge.MaxValue:=MaxY Div EditGang.Value;
   if EditLaenge.MaxValue>MaxY then EditLaenge.MaxValue:=MaxY;
   EditBreite.MaxValue:=MaxX Div EditGang.Value;
   if EditBreite.MaxValue>MaxX then EditBreite.MaxValue:=MaxX;
  end;

 PROCEDURE TIrrgarten.WEGSUCHEN(LA:IRR;LL,LB,G:INTEGER);
  VAR KR,X,Y,VA,AN,K,L,VN,R,A,Z,S,ZS,RISTART:INTEGER;
      KS,LS,RS:ARRAY[1..3000]OF INTEGER;
  BEGIN
   BILDSCHIRM(LABY,LAENGE,BREITE,GROESSE);
   Bild.Canvas.Pen.Color:=clRed;
   VA:=0;AN:=0;KR:=1;RISTART:=1;
   X:=Delta+G*XEINGANG-G DIV 2;Y:=Delta+G*YEINGANG-G DIV 2;
   CASE SUCHRICHTUNG OF
      1 : Begin
           RISTART:=4; // unten
           Bild.Canvas.TextOut(XEingang*G+2,YEingang*G+Delta+3,'S');
          End;
      2 : Begin
           RISTART:=8; // links
           Bild.Canvas.TextOut(XEingang*G-4,YEingang*G,'S');
          End;
      4 : Begin
           RISTART:=1; // oben
           Bild.Canvas.TextOut(XEingang*G+2,YEingang*G-3,'S');
          End;
      8 : Begin
           RISTART:=2; // rechts
           Bild.Canvas.TextOut(XEingang*G+Delta,YEingang*G,'S');
          End;
     END;
   Case AusgangWahl.ItemIndex of
     0 : Bild.Canvas.TextOut(XAusgang*G+2,YAusgang*G-3,'Z');  // oben
     1 : Bild.Canvas.TextOut(XAusgang*G+Delta,YAusgang*G,'Z');  // rechts
     2 : Bild.Canvas.TextOut(XAusgang*G+2,YAusgang*G+Delta+3,'Z'); // unten
     3 : Bild.Canvas.TextOut(XAusgang*G-4,YAusgang*G,'Z');// links
    End;
   REPEAT
    K:=YEINGANG;L:=XEINGANG;VN:=VA;VA:=0;R:=RISTART;
    REPEAT
     IF (K=YEINGANG) AND (L=XEINGANG) THEN
      BEGIN R:=RISTART;KR:=1;KS[KR]:=K;LS[KR]:=L END;
     Z:=LA[K,L];ZS:=Z-R;IF AN=2 THEN LA[K,L]:=Z+16;
     IF (12<Z) OR (Z=11) OR (Z=7) THEN INC(VA);
     IF ZS=0 THEN S:=R
     ELSE BEGIN
           IF (ZS=8) OR (ZS=4) OR (ZS=2) OR (ZS=1) THEN S:=ZS
           ELSE BEGIN
                 A:=8;WHILE ZS<A DO A:=A DIV 2;
                 S:=A;INC(KR);KS[KR]:=K;LS[KR]:=L;RS[KR]:=R
                END
          END;
     CASE S OF
      1: BEGIN
          DEC(K);R:=4;
          IF AN=2 THEN BEGIN LINE(X,Y,X,Y-G);Y:=Y-G END
         END;
      2: BEGIN
          INC(L);R:=8;
          IF AN=2 THEN BEGIN LINE(X,Y,X+G,Y);X:=X+G END
         END;
      4: BEGIN
          INC(K);R:=1;
          IF AN=2 THEN BEGIN LINE(X,Y,X,Y+G);Y:=Y+G END
         END;
      8: BEGIN
          DEC(L);R:=2;
          IF AN=2 THEN BEGIN LINE(X,Y,X-G,Y);X:=X-G END
         END
     END;
     IF (KS[KR]=K) AND (LS[KR]=L) THEN
      BEGIN LA[K,L]:=LA[K,L]-R;R:=RS[KR];DEC(KR) END
    UNTIL (YAUSGANG=K) AND (XAUSGANG=L);
    IF (VA=VN) OR (AN=2) THEN INC(AN) ELSE AN:=0
   UNTIL AN=3
  END;

 procedure TIrrgarten.WegsucheClick(Sender: TObject);
  begin
   WEGSUCHEN(LABY,LAENGE,BREITE,GROESSE);
   Wegsuche.Enabled:=False;
  end;

 procedure TIrrgarten.DruckenClick(Sender: TObject);
  var PrnRect,ImageRect:TRect;
  begin
   Screen.Cursor:=crHourglass;
   Printer.BeginDoc;
   SetMapMode(Printer.Canvas.Handle,MM_LOMETRIC);// Umstellen auf 1/10mm
   // ACHTUNG : positive y-Werte nach OBEN!!!
   PrnRect:=Rect(100,-100,2*ClientWidth,2*(-ClientHeight-100)); // s.o.
   ImageRect:=Rect(0,0,Bild.Width,Bild.Height);
   Printer.Canvas.CopyRect(PrnRect,Bild.Canvas,ImageRect);
   Printer.EndDoc;
   Screen.Cursor:=crDefault;
  end;

 procedure TIrrgarten.MenschsucheClick(Sender: TObject);
  var Farbe:TColor;
      G:Integer;
      Rect:TRect;
  begin
   Bild.Canvas.Brush.Color:=clWhite;// Hintergrundfarbe
   Rect.Left:=0;Rect.Top:=0;
   Rect.Right:=Bild.Width;Rect.Bottom:=Bild.Height;
   Bild.Canvas.FillRect(Rect);// Formular fllen
   BILDSCHIRM(LABY,LAENGE,BREITE,GROESSE);
   Farbe:=clBlack;G:=EditGang.Value;
   XSuch:=Delta+G*XEINGANG-G DIV 2;YSuch:=Delta+G*YEINGANG-G DIV 2;
   XPos:=XEINGANG;YPos:=YEINGANG;
   Bild.Canvas.Pixels[XSuch,YSuch]:=Farbe;
   ButtonHoch.Visible:=True;ButtonRechts.Visible:=True;
   ButtonUnten.Visible:=True;ButtonLinks.Visible:=True;
   EditRi.SetFocus
  end;

 procedure TIrrgarten.ButtonWahl(Sender: TObject);
  var G:Integer;
  begin
   G:=EditGang.Value;
   IF Sender=ButtonHoch then
    IF Laby[YPos,XPos] IN[1,3,5,7,9,11,13,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Dec(YSuch,G);Dec(YPos);
     END
    Else Beep;
   IF Sender=ButtonRechts then
    IF Laby[YPos,XPos] IN[2,3,6,7,10,11,14,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Inc(XSuch,G);Inc(XPos);
     END
    Else Beep;
   IF Sender=ButtonUnten then
    IF Laby[YPos,XPos] IN[4,5,6,7,12,13,14,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Inc(YSuch,G);Inc(YPos);
     END
    Else Beep;
   IF Sender=ButtonLinks then
    IF Laby[YPos,XPos] IN[8,9,10,11,12,13,14,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Dec(XSuch,G);Dec(XPos);
     END
    Else Beep; 
   Bild.Canvas.Pixels[XSuch,YSuch]:=clBlack;
   EditRi.SetFocus;
   if (XPos=XAusgang) and (YPos=YAusgang) then
     MessageDlg('Prima, du hast das Ziel erreicht!',mtInformation,[mbOk],0)
  end;

 procedure TIrrgarten.EditRiKeyDown(Sender: TObject; var Key: Word;
                                    Shift: TShiftState);
  var G:Integer;
  begin
   G:=EditGang.Value;
   if Key=VK_Up then
    IF Laby[YPos,XPos] IN[1,3,5,7,9,11,13,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Dec(YSuch,G);Dec(YPos);
     END
    Else Beep;
   if Key=VK_Right then
    IF Laby[YPos,XPos] IN[2,3,6,7,10,11,14,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Inc(XSuch,G);Inc(XPos);
     END
    Else Beep;
   if Key=VK_Down then
    IF Laby[YPos,XPos] IN[4,5,6,7,12,13,14,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Inc(YSuch,G);Inc(YPos);
     END
    Else Beep;
   if Key=VK_Left then
    IF Laby[YPos,XPos] IN[8,9,10,11,12,13,14,15] THEN
     BEGIN
      Bild.Canvas.Pixels[XSuch,YSuch]:=clWhite;
      Dec(XSuch,G);Dec(XPos);
     END
    Else Beep;
    Bild.Canvas.Pixels[XSuch,YSuch]:=clBlack;
   if (XPos=XAusgang) and (YPos=YAusgang) then
     MessageDlg('Prima, du hast das Ziel erreicht!',mtInformation,[mbOk],0)
  end;

end.


