unit Info;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
     Buttons, ExtCtrls, ShellApi;

type
  TInfoBox = class(TForm)
    Panel1: TPanel;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Hinweis: TLabel;
    Internet: TLabel;
    MailTo: TLabel;
    Panel: TPanel;
    Bild: TImage;
    Timer: TTimer;
    procedure InternetClick(Sender: TObject);
    procedure InternetMouseEnter(Sender: TObject);
    procedure InternetMouseLeave(Sender: TObject);
    procedure MailToMouseEnter(Sender: TObject);
    procedure MailToMouseLeave(Sender: TObject);
    procedure MailToClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure CopyrightClick(Sender: TObject);
  private
    { Private declarations }
   Farbe,FarbListe:Array[1..9]of TColor;
  public
    { Public declarations }
  end;

var
  InfoBox: TInfoBox;

implementation

uses About;

{$R *.DFM}

 procedure TInfoBox.InternetClick(Sender: TObject);
  begin
   ShellExecute(Application.Handle,'open','http://www.meister-fiete.de',nil,nil,sw_normal);
  end;

 procedure TInfoBox.InternetMouseEnter(Sender: TObject);
  begin
   Internet.Font.Style:=[fsBold, fsUnderline];
   Internet.Font.Color:=clLime;
   Internet.Font.Size:=14;
  end;

 procedure TInfoBox.InternetMouseLeave(Sender: TObject);
  begin
   Internet.Font.Style:=[fsBold];
   Internet.Font.Color:=clBlack;
   Internet.Font.Size:=10;
  end;

 procedure TInfoBox.MailToMouseEnter(Sender: TObject);
  begin
   MailTo.Font.Style:=[fsBold, fsUnderline];
   MailTo.Font.Color:=clLime;
   MailTo.Font.Size:=14;
  end;

 procedure TInfoBox.MailToMouseLeave(Sender: TObject);
  begin
   MailTo.Font.Style:=[fsBold];
   MailTo.Font.Color:=clBlack;
   MailTo.Font.Size:=10;
  end;

 procedure TInfoBox.MailToClick(Sender: TObject);
  begin
   ShellExecute(Application.Handle,'open','mailto:Hal@meister-fiete.de?subject=Probieren',nil,nil,sw_normal);
  end;

 procedure TInfoBox.FormCreate(Sender: TObject);
  begin
   Farbe[1]:=clWhite;Farbe[2]:=clRed;Farbe[3]:=clYellow;
   Farbe[4]:=clGreen;Farbe[5]:=clFuchsia;Farbe[6]:=clAqua;
   Farbe[7]:=clBlue;Farbe[8]:=clBlack;Farbe[9]:=clMaroon;
   FarbListe:=Farbe;
    with Bild.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,Bild.Width,Bild.Height);
     Brush.Color:=Farbe[1];
     Ellipse(10,10,30,30);
     Brush.Color:=Farbe[2];
     Ellipse(50,15,70,35);
     Brush.Color:=Farbe[3];
     Ellipse(30,20,50,40);
     Brush.Color:=Farbe[4];
     Ellipse(5,50,25,70);
     Brush.Color:=Farbe[5];
     Ellipse(25,40,45,60);
     Brush.Color:=Farbe[6];
     Ellipse(50,50,70,70);
    end;
  end;

 procedure TInfoBox.TimerTimer(Sender: TObject);
  var T:TColor;
      K:Integer;
  begin
   with Bild.Canvas do
    begin
     T:=FarbListe[1];
     for K:=1 to 5 do FarbListe[K]:=FarbListe[K+1];
     FarbListe[6]:=T;
     Brush.Color:=FarbListe[1];
     Ellipse(10,10,30,30);
     Brush.Color:=FarbListe[2];
     Ellipse(50,15,70,35);
     Brush.Color:=FarbListe[3];
     Ellipse(30,20,50,40);
     Brush.Color:=FarbListe[4];
     Ellipse(5,50,25,70);
     Brush.Color:=FarbListe[5];
     Ellipse(25,40,45,60);
     Brush.Color:=FarbListe[6];
     Ellipse(50,50,70,70);
    end;
  end;

 procedure TInfoBox.CopyrightClick(Sender: TObject);
  begin Autor.ShowModal end;

end.


