unit Poincare;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls, Optionen, Buttons, ImgList, Info, Regeln;

type
  TFractal = class(TForm)
    OpenDialog: TOpenDialog;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Start: TMenuItem;
    Optionen: TMenuItem;
    Bild: TImage;
    ButtonRechts: TBitBtn;
    BildListe: TImageList;
    ButtonLinks: TBitBtn;
    SaveDialog: TSaveDialog;
    Hilfe: TMenuItem;
    Hinweise: TMenuItem;
    N2: TMenuItem;
    Info: TMenuItem;
    procedure LadenClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure Transformiere;
    procedure OptionenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonRechtsClick(Sender: TObject);
    procedure ButtonLinksClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure HinweiseClick(Sender: TObject);
  private
    { Private-Deklarationen }
   TransformationsNr,TransformationsMax:Integer;
   Kopie:TBitMap;
  public
    { Public-Deklarationen }
   Matrix:Array[1..2,1..2]of Integer;
  end;

var
  Fractal: TFractal;

implementation

{$R *.dfm}
{$R+,Q+}

 procedure TFractal.LadenClick(Sender: TObject);
  begin
   with OpenDialog do
    begin
     Filter:='Bilddateien(*.bmp)|*.bmp|Alle (*.*)|*.*';
     DefaultExt:='bmp';
     if Execute then
      begin
       try
        Bild.Picture.Bitmap.LoadFromFile(FileName);
        ButtonRechts.Enabled:=False;
        ButtonLinks.Enabled:=False;
       except
        MessageDLG('BildDatei '+FileName+' nicht gefunden!',mtError,[mbOk],0);
       end
      end
     else MessageDlg('Keine Datei geladen!',mtError,[mbOk],0);
    end
  end;

 procedure TFractal.BeendenClick(Sender: TObject);
  begin close end;

 procedure TFractal.Transformiere;
  var X,Y,XNeu,YNeu,Farbe:Integer;
  begin
   Screen.Cursor:=crHourGlass;
   for X:=0 to 199 do
    for Y:=0 to 199 do
     begin
      Farbe:=Bild.Canvas.Pixels[X,Y];
      XNeu:=(Matrix[1,1]*X+Matrix[1,2]*Y);
      YNeu:=(Matrix[2,1]*X+Matrix[2,2]*Y);
      while XNeu>199 do dec(XNeu,200);
      while YNeu>199 do dec(YNeu,200);
      Kopie.Canvas.Pixels[XNeu,YNeu]:=Farbe;
     end;
   Bild.Picture.Bitmap:=Kopie;
   Screen.Cursor:=crDefault;
  end;

 procedure TFractal.StartClick(Sender: TObject);
  begin
   ButtonRechts.Enabled:=True;
   ButtonLinks.Enabled:=True;
   BildListe.Clear;
   TransformationsNr:=0;TransformationsMax:=0;
   BildListe.Add(Bild.Picture.Bitmap,Nil);
   Caption:='Poincarsche Wiederkehr: Bild '+IntToStr(TransformationsNr);
  end;

 procedure TFractal.OptionenClick(Sender: TObject);
  begin
   Options.ShowModal;
  end;

 procedure TFractal.FormCreate(Sender: TObject);
  begin
   Kopie:=TBitMap.Create;
   Kopie.Height:=Bild.Picture.Bitmap.Height;
   Kopie.Width:=Bild.Picture.Bitmap.Width;
   Matrix[1,1]:=1;Matrix[1,2]:=1;
   Matrix[2,1]:=1;Matrix[2,2]:=2;
   ButtonRechts.Enabled:=False;
   ButtonLinks.Enabled:=False;
  end;

 procedure TFractal.FormDestroy(Sender: TObject);
  begin Kopie.Free end;

 procedure TFractal.ButtonRechtsClick(Sender: TObject);
  begin
   inc(TransformationsNr);
   if TransformationsMax<TransformationsNr then
    begin
     Transformiere;
     TransformationsMax:=TransformationsNr;
     BildListe.Add(Bild.Picture.Bitmap,Nil);
    end
   else BildListe.Draw(Bild.Canvas,0,0,TransformationsNr);
   Bild.Repaint;
   Caption:='Poincarsche Wiederkehr: Bild '+IntToStr(TransformationsNr);
  end;

 procedure TFractal.ButtonLinksClick(Sender: TObject);
  begin
   if TransformationsNr=0 then exit;
   dec(TransformationsNr);
   Caption:='Poincarsche Wiederkehr: Bild '+IntToStr(TransformationsNr);
   BildListe.Draw(Bild.Canvas,0,0,TransformationsNr);
   Bild.Repaint;
  end;

 procedure TFractal.SpeichernClick(Sender: TObject);
  begin
   with SaveDialog do
    begin
     Filter:='Bilddateien(*.bmp)|*.bmp|Alle (*.*)|*.*';
     DefaultExt:='bmp';
     Options:=[ofOverwritePrompt];
     if Execute then
      begin
       try
        Bild.Picture.Bitmap.SaveToFile(FileName);
       except
        MessageDLG('BildDatei '+FileName+' nicht gespeichert!',mtError,[mbOk],0);
       end
      end
     else MessageDlg('Keine Datei gespeichert!',mtError,[mbOk],0);
    end
  end;

 procedure TFractal.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TFractal.HinweiseClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

end.

