unit NeuUnit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TNewGame = class(TForm)
    OK: TButton;
    Label1: TLabel;
    Name1: TEdit;
    Label2: TLabel;
    Comp1: TCheckBox;
    Label3: TLabel;
    Name2: TEdit;
    Label4: TLabel;
    Comp2: TCheckBox;
    Abbrechen: TButton;
    Seitentausch: TBitBtn;
    TopImage: TImage;
    BottomImage: TImage;
    LeftImage: TImage;
    RightImage: TImage;
    Label5: TLabel;
    Netzwerk: TCheckBox;
    procedure OKClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Comp1Click(Sender: TObject);
    procedure Comp2Click(Sender: TObject);
    procedure AbbrechenClick(Sender: TObject);
    procedure SeitentauschClick(Sender: TObject);
    procedure Name1KeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
    procedure ZeichneRand;
    procedure NetzwerkClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  NewGame: TNewGame;

implementation

uses ReversiUnit1;

{$R *.dfm}

 procedure TNewGame.FormHide(Sender: TObject);
  begin
   Reversi.enabled:=true;
  end;

 procedure TNewGame.Comp1Click(Sender: TObject);
  begin
   if (Comp1.Checked)and(Comp2.Checked) then Comp2.Checked:=false;
  end;

 procedure TNewGame.Comp2Click(Sender: TObject);
  begin
   if (Comp1.Checked)and(Comp2.Checked) then Comp1.Checked:=false;
  end;

 procedure TNewGame.OKClick(Sender: TObject);
  begin
   if Name1.Text=Name2.Text then
    begin
     MessageDLG('Bitte whlen Sie unterschiedliche Spielernamen!',mtInformation,[mbOK],0);
     exit;
    end;
   Reversi.Name1:=Name1.Text;
   Reversi.Name2:=Name2.Text;
   if Comp1.Checked then Reversi.Computer:=Spieler1
   else if Comp2.Checked then Reversi.Computer:=Spieler2
        else Reversi.Computer:=Keiner;
   Reversi.Init;
   Reversi.ZeichneSteine(Reversi.F);
   NewGame.Hide;
  end;

 procedure TNewGame.AbbrechenClick(Sender: TObject);
  begin NewGame.Hide end;

 procedure TNewGame.SeitentauschClick(Sender: TObject);
  var temp:string;
  begin
   temp:=Name1.Text;
   Name1.Text:=Name2.Text;
   Name2.Text:=temp;
   Comp1.Checked:=Comp2.Checked;
   Comp2.Checked:=Comp1.Checked
  end;

 procedure TNewGame.Name1KeyPress(Sender: TObject; var Key: Char);
  begin
   if key=#13 then OK.Click;
   if key=#27 then Abbrechen.Click;
  end;

 procedure TNewGame.FormShow(Sender: TObject);
  begin
   Top:=(Screen.Height div 2) - (Height div 2);
   Left:=(Screen.Width div 2)- (Width div 2);
   Name1.Text:=Reversi.Name1;
   Name2.Text:=Reversi.Name2;
   Comp1.Checked:=Reversi.Computer=Spieler1;
   Comp2.Checked:=Reversi.Computer=Spieler2;
  end;

 procedure TNewGame.FormCreate(Sender: TObject);
  begin
   SetWindowRgn(handle,CreateRoundRectRgn(0,0,clientwidth,clientheight,50,50),true );
   ZeichneRand;
  end;

 procedure TNewGame.ZeichneRand;
  var k:Integer;
      Farbe:TColor;
  begin
   TopImage.Width:=ClientWidth;
   TopImage.Top:=0;
   TopImage.Left:=0;
   BottomImage.Width:=ClientWidth;
   BottomImage.Top:=ClientHeight-26;
   BottomImage.Left:=0;
   for k:=0 to ClientWidth do
   begin
        Farbe:=RGB(Round(255*k/ClientWidth), Round(255*k/ClientWidth), 0);
        with TopImage.Canvas do
        begin
             Pen.Color:=Farbe;
             Pen.Width:=2;
             Pen.Style:=psInsideFrame;
             MoveTo(k,0);
             LineTo(k,25);
        end;
        with BottomImage.Canvas do
        begin
             Pen.Color:=Farbe;
             Pen.Width:=2;
             Pen.Style:=psInsideFrame;
             MoveTo(ClientWidth-k,0);
             LineTo(ClientWidth-k,25);
        end;
   end;
   LeftImage.Top:=25;
   LeftImage.Left:=0;
   LeftImage.Width:=3;
   LeftImage.Height:=ClientHeight-50;
   RightImage.Top:=25;
   RightImage.Left:=ClientWidth-4;
   RightImage.Width:=3;
   RightImage.Height:=ClientHeight-50;
   for k:=0 to LeftImage.Height do
    begin
     Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
     with LeftImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=5;
       Pen.Style:=psInsideFrame;
       MoveTo(0,k);
       LineTo(2,k);
      end;
     Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
     with RightImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=5;
       Pen.Style:=psInsideFrame;
       MoveTo(0,LeftImage.Height-k);
       LineTo(2,LeftImage.Height-k);
      end;
    end;
  end;

 procedure TNewGame.WMNCHitTest (var M: TWMNCHitTest);
  begin
   inherited;
   if ((PtInRect(Rect(TopImage.Left,TopImage.Top,TopImage.Left+TopImage.Width,TopImage.Top+TopImage.Height), Point(M.Pos.X-Left,M.Pos.Y-Top)))
   or (PtInRect(Rect(BottomImage.Left,BottomImage.Top,BottomImage.Left+BottomImage.Width,BottomImage.Top+BottomImage.Height), Point(M.Pos.X-Left,M.Pos.Y-Top))))
   and (M.Result=htClient) then M.Result:=htCaption;
  end;

 procedure TNewGame.NetzwerkClick(Sender: TObject);
  begin
   if not Netzwerk.Checked then
    with Reversi do
     begin
      ClientSocket.Active:=False;
      ServerSocket.Active:=False;
      Connected:=False;
      WhiteMoves:=True;
      IsServer:=True;
      ShallMove:=not(IsServer xor WhiteMoves);
      UpdateCaption;
     end
  end;

end.

