unit OptionenUnit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TOptions = class(TForm)
    ColorDialog: TColorDialog;
    OK: TButton;
    Abbrechen: TButton;
    Image1: TImage;
    Image2: TImage;
    Haken1: TImage;
    Haken2: TImage;
    Label1: TLabel;
    LabelS1: TLabel;
    LabelS2: TLabel;
    LabelM: TLabel;
    LabelF: TLabel;
    LabelT: TLabel;
    Option1: TLabel;
    Option2: TLabel;
    Kaesten: TImage;
    ColorS1: TImage;
    ColorS2: TImage;
    ColorM: TImage;
    ColorF: TImage;
    ColorT: TImage;
    TopImage: TImage;
    BottomImage: TImage;
    LeftImage: TImage;
    RightImage: TImage;
    Label5: TLabel;
    procedure ColorS1Click(Sender: TObject);
    function farbauswahl(Farbe:TColor):TColor;
    procedure OKClick(Sender: TObject);
    procedure AbbrechenClick(Sender: TObject);
    procedure SpeichernOptionen;
    procedure LadenOptionen;
    procedure FormCreate(Sender: TObject);
    procedure LabelS1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LabelS1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DefaultOptionen;
    procedure Aktualisieren;
    procedure ZeichneCursor;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
    procedure OKKeyPress(Sender: TObject; var Key: Char);
    procedure ZeichneKaesten;
    procedure ZeichneRand;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Options: TOptions;

implementation

uses ReversiUnit1, NeuUnit2;

{$R *.dfm}

 procedure TOptions.OKClick(Sender: TObject);
  begin
   SpeichernOptionen;
   Options.Hide;
  end;

 procedure TOptions.AbbrechenClick(Sender: TObject);
  begin Options.Hide end;

 procedure TOptions.FormClose(Sender: TObject; var Action: TCloseAction);
  begin
   LadenOptionen;
   Aktualisieren;
  end;

 procedure TOptions.FormShow(Sender: TObject);
  begin
   Top:=(Screen.Height div 2) - (Height div 2);
   Left:=(Screen.Width div 2)- (Width div 2);
  end;

 function TOptions.Farbauswahl(Farbe:TColor):TColor;
  begin
   with ColorDialog do
    begin
     Color:=Farbe;
     if execute then Result:=Color
     else Result:=Farbe;
    end;
  end;

 procedure TOptions.SpeichernOptionen;
  var f:TextFile;
      k:Integer;
  begin
   AssignFile(f,'Settings.ini');
   Rewrite(f);
   for k:=1 to length(Reversi.Farben) do
    Writeln(f,ColorToString(Reversi.Farben[k]));
   write(f,IntToStr(Ord(Reversi.Opt1)));
   write(f,IntToStr(Ord(Reversi.Opt2)));
   CloseFile(f);
  end;

 procedure TOptions.LadenOptionen;
  var f:TextFile;
      k:Integer;
      zeile:string;
  begin
   if FileExists('Settings.ini') then
    begin
     AssignFile(f,'Settings.ini');
     Reset(f);
     for k:=1 to length(Reversi.Farben) do
      begin
       ReadLn(f,zeile);
       Reversi.Farben[k]:=StringToColor(zeile);
      end;
     ReadLn(f,zeile);
     Reversi.Opt1:=zeile[1]='1';
     Reversi.Opt2:=zeile[2]='1';
     CloseFile(f);
    end
   else DefaultOptionen;
  end;

 procedure TOptions.DefaultOptionen;
  begin
   Reversi.Farben[1]:=clwhite;
   Reversi.Farben[2]:=clblack;
   Reversi.Farben[3]:=$00C7C7C7;
   Reversi.Farben[4]:=clBtnFace;
   Reversi.Farben[5]:=clGray;
  end;

 procedure TOptions.Aktualisieren;
  begin
   with ColorS1.Canvas do
    begin Brush.Color:=Reversi.Farben[1];FillRect(Rect(0,0,20,20)) end;
   with ColorS2.Canvas do
    begin Brush.Color:=Reversi.Farben[2];FillRect(Rect(0,0,20,20)) end;
   with ColorM.Canvas do
    begin Brush.Color:=Reversi.Farben[3];FillRect(Rect(0,0,20,20)) end;
   with ColorF.Canvas do
    begin Brush.Color:=Reversi.Farben[4];FillRect(Rect(0,0,20,20)) end;
   with ColorT.Canvas do
    begin Brush.Color:=Reversi.Farben[5];FillRect(Rect(0,0,20,20)) end;
   Haken1.Visible:=Reversi.Opt1;
   Haken2.Visible:=Reversi.Opt2;
   Reversi.Color:=Reversi.Farben[4];
   NewGame.Color:=Reversi.Farben[4];
   Options.Color:=Reversi.Farben[4];
   if Reversi.gestartet then
    begin
     Reversi.ZeichneGitter(Reversi.Brett);
     Reversi.ZeichneSteine(Reversi.F)
    end;
   ZeichneKaesten
  end;

 procedure TOptions.FormCreate(Sender: TObject);
  begin
   SetWindowRgn(handle, CreateRoundRectRgn(0, 0, clientwidth, clientheight, 50, 50 ), true );
   LadenOptionen;
   Aktualisieren;
   ZeichneRand;
  end;

 procedure TOptions.ZeichneRand;
  var k:Integer;
      Farbe:TColor;
  begin
   TopImage.Width:=ClientWidth;
   TopImage.Top:=0;
   TopImage.Left:=0;
   BottomImage.Width:=ClientWidth;
   BottomImage.Top:=ClientHeight-26;
   BottomImage.Left:=0;
   for k:=0 to ClientWidth do
    begin
     Farbe:=RGB(Round(255*k/ClientWidth), Round(255*k/ClientWidth), 0);
     with TopImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=2;
       Pen.Style:=psInsideFrame;
       MoveTo(k,0);
       LineTo(k,25);
      end;
     with BottomImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=2;
       Pen.Style:=psInsideFrame;
       MoveTo(ClientWidth-k,0);
       LineTo(ClientWidth-k,25);
      end;
    end;
   LeftImage.Top:=25;
   LeftImage.Left:=0;
   LeftImage.Width:=3;
   LeftImage.Height:=ClientHeight-50;
   RightImage.Top:=25;
   RightImage.Left:=ClientWidth-4;
   RightImage.Width:=3;
   RightImage.Height:=ClientHeight-50;
   for k:=0 to LeftImage.Height do
    begin
     Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
     with LeftImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=5;
       Pen.Style:=psInsideFrame;
       MoveTo(0,k);
       LineTo(2,k);
      end;
     Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
     with RightImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=5;
       Pen.Style:=psInsideFrame;
       MoveTo(0,LeftImage.Height-k);
       LineTo(2,LeftImage.Height-k);
      end;
    end;
  end;

 procedure TOptions.ZeichneKaesten;
  var k:integer;
   begin
    with Kaesten.Canvas do
     begin
      Brush.Color:=Reversi.Farben[4];
      FillRect(Rect(0,0,24,152));
      Pen.Width:=2;
      Pen.Color:=clblack;
      for k:=0 to 4 do
       begin
        MoveTo(1,k*32+1);
        LineTo(23,k*32+1);
        LineTo(23,k*32+23);
        LineTo(1,k*32+23);
        LineTo(1,k*32);
       end;
     end;
  end;

 procedure TOptions.WMNCHitTest (var M: TWMNCHitTest);
  begin
   inherited;
   if ((PtInRect(Rect(TopImage.Left,TopImage.Top,TopImage.Left+TopImage.Width,TopImage.Top+TopImage.Height), Point(M.Pos.X-Left,M.Pos.Y-Top)))
   or (PtInRect(Rect(BottomImage.Left,BottomImage.Top,BottomImage.Left+BottomImage.Width,BottomImage.Top+BottomImage.Height), Point(M.Pos.X-Left,M.Pos.Y-Top))))
   and (M.Result=htClient) then M.Result:=htCaption;
  end;

 procedure TOptions.ZeichneCursor;
  begin
   //blas
  end;

 procedure TOptions.LabelS1MouseDown(Sender: TObject; Button: TMouseButton;
                                     Shift: TShiftState; X, Y: Integer);
 var Farbe:TColor;
  begin
   Farbe:=clgreen;
   if Sender=Option1 then Option1.Font.Color:=Farbe;
   if Sender=Option2 then Option2.Font.Color:=Farbe;
   if Sender=LabelS1 then LabelS1.Font.Color:=Farbe;
   if Sender=LabelS2 then LabelS2.Font.Color:=Farbe;
   if Sender=LabelM then LabelM.Font.Color:=Farbe;
   if Sender=LabelF then LabelF.Font.Color:=Farbe;
   if Sender=LabelT then LabelT.Font.Color:=Farbe;
  end;

 procedure TOptions.LabelS1MouseUp(Sender: TObject; Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
  var Farbe:TColor;
  begin
   Farbe:=clblack;
   if Sender=Option1 then Option1.Font.Color:=Farbe;
   if Sender=Option2 then Option2.Font.Color:=Farbe;
   if Sender=LabelS1 then LabelS1.Font.Color:=Farbe;
   if Sender=LabelS2 then LabelS2.Font.Color:=Farbe;
   if Sender=LabelM then LabelM.Font.Color:=Farbe;
   if Sender=LabelF then LabelF.Font.Color:=Farbe;
   if Sender=LabelT then LabelT.Font.Color:=Farbe;
  end;

 procedure TOptions.ColorS1Click(Sender: TObject);
  begin
   if Sender=ColorS1 then Reversi.Farben[1]:=Farbauswahl(Reversi.Farben[1]);
   if Sender=ColorS2 then Reversi.Farben[2]:=Farbauswahl(Reversi.Farben[2]);
   if Sender=ColorM then Reversi.Farben[3]:=Farbauswahl(Reversi.Farben[3]);
   if Sender=ColorF then Reversi.Farben[4]:=Farbauswahl(Reversi.Farben[4]);
   if Sender=ColorT then Reversi.Farben[5]:=Farbauswahl(Reversi.Farben[5]);
   if Sender= Option1 then Reversi.Opt1:=not Reversi.Opt1;
   if Sender= Option2 then Reversi.Opt2:=not Reversi.Opt2;
   Aktualisieren;
  end;

 procedure TOptions.OKKeyPress(Sender: TObject; var Key: Char);
  begin
   if key=#13 then OK.Click;
   if key=#27 then Abbrechen.Click;
  end;

end.

