unit ReversiUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, Menus, ExtCtrls, ScktComp;

type
   TMove=Byte;
   TSpielFeld=Array[1..100]of Byte;
   TInhalt=Byte;
   TSpielZug=Byte;
   TSpielZugListe=Array of TSpielZug;
   TSpielSteine=Array[1..2] of Byte;
   TSpieler=(Spieler1,Spieler2,Keiner);
  TReversi = class(TForm)
    LabelAmZug: TLabel;
    Image: TImage;
    Neu: TLabel;
    Regeln: TLabel;
    Info: TLabel;
    Optionen: TLabel;
    LabelSteine1: TLabel;
    LabelSteine2: TLabel;
    Doppelpunkt: TLabel;
    LabelSpielstand: TLabel;
    Ausschalten: TImage;
    TopImage: TImage;
    Label4: TLabel;
    BottomImage: TImage;
    LeftImage: TImage;
    RightImage: TImage;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    NWSpiel: TLabel;
    Procedure MachZug(Var F:TSpielFeld;Zug:TSpielZug;Amzug:TSpieler;
                      var Steine:TSpielSteine);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Init;
    procedure NeuClick(Sender: TObject);
    function AndererSpieler(Amzug:TSpieler):TSpieler;
    procedure WechselSpieler(var Amzug:TSpieler);
    function GenZugListe(F:TSpielFeld;Amzug:TSpieler; Var ZL:TSpielZugListe):byte;
    procedure Moeglichkeiten(var F:TSpielFeld;AmZug:TSpieler;var ZL:TSpielZugListe);
    function Spielende:Boolean;
    function VorschauZug(F:TSpielFeld;Zug:TSpielZug;Amzug:TSpieler;var VL:TSpielZugListe):byte;
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
    procedure ZeichneGitter(var Brett:Trect);
    function CellToRect(Cell:TSpielZug;Brett:TRect;FB,TB:Byte):TRect;
    procedure ZeichneSteine(F:TSpielFeld);
    procedure NeuMouseDown(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure NeuMouseUp(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
    function KoordsToCell(x,y:Integer):TSpielZug;
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure AusschaltenClick(Sender: TObject);
    procedure OptionenClick(Sender: TObject);
    procedure ZeichneRand;
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure UpdateCaption;
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormDestroy(Sender: TObject);
    procedure NWSpielClick(Sender: TObject);

  private
    { Private-Deklarationen }
    AmZug:TSpieler;
    Steine:TSpielSteine;
    LetztesFeld:Byte;
  public
    { Public-Deklarationen }
    Brett:TRect;
    F:TSpielFeld;
    Name1,Name2:string;
    Computer:TSpieler;
    gestartet,Connected,Opt1,Opt2,WhiteMoves,IsServer,ShallMove:Boolean;
    Farben:Array[1..5] of TColor;
  end;

var
  Reversi: TReversi;

implementation

uses NeuUnit2, OptionenUnit3, InfoUnit4, RegelnUnit5;

const FB:Byte=35;
      TB:Byte=3;

{$R *.dfm}
{$R+,Q+}
 procedure TReversi.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   CanClose:=MessageDlg('Wollen Sie wirklich beenden?',mtConfirmation,[mbYes,mbNo],0)=mrYes
  end;

 procedure TReversi.AusschaltenClick(Sender: TObject);
  begin close; end;

 procedure TReversi.NeuClick(Sender: TObject);
  begin
   Reversi.Enabled:=false;
   NewGame.Show;
  end;

 procedure TReversi.OptionenClick(Sender: TObject);
  begin Options.Show end;

 procedure TReversi.InfoClick(Sender: TObject);
  begin Form4.Show end;

 procedure TReversi.RegelnClick(Sender: TObject);
  begin Form5.Show end;

 function TReversi.AndererSpieler(Amzug:TSpieler):TSpieler;
  begin
   if AmZug=Spieler1 then Result:=Spieler2 else Result:=Spieler1;
  end;

 procedure TReversi.WechselSpieler(var Amzug:TSpieler);
  begin
   if AmZug=Spieler1 then
    begin
     AmZug:=Spieler2;
     LabelAmZug.Caption:=Name2+' ist am Zug';
     LabelAmZug.Font.Color:=Farben[2];
     Image.cursor:=2
    end
   else
    begin
     AmZug:=Spieler1;
     LabelAmZug.Caption:=Name1+' ist am Zug';
     LabelAmZug.Font.Color:=Farben[1];
     Image.cursor:=1
    end;
  end;

 function TReversi.GenZugListe(F:TSpielFeld;Amzug:TSpieler; Var ZL:TSpielZugListe):byte;
  Const Richtung:Array[1..8] of integer = (-11,-10,-9,-1,1,9,10,11);
  Var k,r,weite,Spieler,Gegner:Byte;
  Begin
   SetLength(ZL,0);
   Spieler:=ord(Amzug<>Spieler1)+1;//der spieler, der dran ist (1 oder 2)
   Gegner:=ord(Amzug=Spieler1)+1;//der spieler, der nicht dran ist
   for k:=12 To 89 Do
   If F[k]>2 then //wenn das feld leer oder markiert ist
    begin
     for r:=1 to 8 do //dann prfe alle 8 richtungen nach anderen steinen
      begin
       weite:=0;
       while F[k+(weite+1)*Richtung[r]]=Gegner do inc(weite);
       if (weite>0)and(F[k+(weite+1)*Richtung[r]]=Spieler) then
        begin
         SetLength(ZL,Length(ZL)+1);
         ZL[Length(ZL)-1]:=k;
         break
        end
      end
    end;
   result:=Length(ZL);
  End;

 Procedure TReversi.MachZug(Var F:TSpielFeld;Zug:TSpielZug;Amzug:TSpieler;
                            var Steine:TSpielSteine);
  Const Richtung:Array[1..8] of integer = (-11,-10,-9,-1,1,9,10,11);
  Var Spieler,Gegner,r,weite:byte;
  Begin
   Spieler:=ord(Amzug<>Spieler1)+1;//der spieler, der dran ist
   Gegner:=ord(Amzug=Spieler1)+1;//der spieler, der nicht dran ist
   F[Zug]:=spieler;
   Inc(Steine[Spieler]);
   weite:=0;
   for r:=1 to 8 do
   begin
    while F[Zug+(weite+1)*Richtung[r]]=Gegner do inc(weite);
    if (weite>0)and(F[Zug+(weite+1)*Richtung[r]]=spieler)  then
     begin
      Inc(Steine[Spieler],weite);
      Dec(Steine[Gegner],weite);
      LabelSteine1.Caption:=IntToStr(Steine[1]);
      LabelSteine2.Caption:=IntToStr(Steine[2]);
      repeat
       F[Zug+weite*Richtung[r]]:=spieler;
        dec(weite);
      until weite=0;//alles umdrehen
     end
    else weite:=0;
   end;
  end;

 procedure TReversi.FormCreate(Sender: TObject);
  var c1,c2: THandle;
  begin
   //cursor laden
   c1:=LoadImage(0,'c2.cur',IMAGE_CURSOR,0,0,LR_DEFAULTSIZE or LR_LOADFROMFILE);
   c2:=LoadImage(0,'c1.cur',IMAGE_CURSOR,0,0,LR_DEFAULTSIZE or LR_LOADFROMFILE);
   if (c1=0)or(c2=0) then
    begin
     MessageDLG('Fehler beim Laden der Cursors.',mtError,[mbOK],0);
     halt;
    end
   else
   begin
    Screen.Cursors[1]:=c1;
    Screen.Cursors[2]:=c2;
   end;
   //end cursor laden
   SetWindowRgn(handle, CreateRoundRectRgn(0, 0, clientwidth, clientheight, 50, 50 ), true );
   Top:=(Screen.Height div 2) - (Height div 2);
   Left:=(Screen.Width div 2)- (Width div 2);
   randomize;
   Name1:='Spieler 1';
   Name2:='Spieler 2';
   gestartet:=false;
   Computer:=Keiner;
   Reversi.DoubleBuffered:=True;
   Opt1:=true;
   Opt2:=true;
   ZeichneRand;
   ServerSocket.Active := True;
   Connected := False;
   IsServer := True;
   ShallMove := False;
  end;

 procedure TReversi.WMNCHitTest (var M: TWMNCHitTest);
  var Position:TPoint;
  begin
   inherited;
   Position:=Point(M.Pos.X-Left,M.Pos.Y-Top);
   if PtInRect(Brett, Point(M.Pos.X-Image.Left-Left,M.Pos.Y-Image.Top-Top)) then exit;
   if PtInRect(Rect(Neu.Left,Neu.Top,Neu.Left+Neu.Width,Neu.Top+Neu.Height), Position) then exit;
   if PtInRect(Rect(Optionen.Left,Optionen.Top,Optionen.Left+Optionen.Width,Optionen.Top+Optionen.Height), Position) then exit;
   if PtInRect(Rect(NWSpiel.Left,NWSpiel.Top,NWSpiel.Left+NWSpiel.Width,NWSpiel.Top+NWSpiel.Height), Position) then exit;
   if PtInRect(Rect(Regeln.Left,Regeln.Top,Regeln.Left+Regeln.Width,Regeln.Top+Regeln.Height), Position) then exit;
   if PtInRect(Rect(Info.Left,Info.Top,Info.Left+Info.Width,Info.Top+Info.Height), Position) then exit;
   if PtInRect(Rect(Ausschalten.Left,Ausschalten.Top,Ausschalten.Left+Ausschalten.Width,Ausschalten.Top+Ausschalten.Height), Position) then exit;
   if M.Result=htClient then M.Result:=htCaption;
  end;

 procedure TReversi.Init;
  var k:byte;
      ZL:TSpielZugListe;
  begin
   if NewGame.Netzwerk.Checked then
    begin
     NWSpiel.Enabled:=True;
     WhiteMoves:=True;
    end
   else
    begin
     NWSpiel.Enabled:=False;
     ClientSocket.Active:=False;
     ServerSocket.Active:=True;
     Connected:=False;
     WhiteMoves:=True;
     IsServer:=True;
     ShallMove:=not(IsServer xor WhiteMoves);
     Label4.Caption:='Othello - The Game';
    end;
   AmZug:=Spieler1;
   LabelAmZug.Caption:=Name1+' ist am Zug';
   LabelAmZug.Font.Color:=Farben[1];
   Image.cursor:=1;
   for k:=1 to 100 do
    begin
     if (k<11)or(k>90)or(k mod 10 in [1,0]) then F[k]:=0
     else F[k]:=3;
    end;
   F[45]:=2;//Random(2)+1;
   F[46]:=ord(F[45]=1)+1;
   F[56]:=F[45];
   F[55]:=F[46];
   Moeglichkeiten(F,AmZug,ZL);
   Steine[1]:=2;
   Steine[2]:=2;
   LabelSteine1.Caption:=IntToStr(Steine[1]);
   LabelSteine2.Caption:=IntToStr(Steine[2]);
   LabelSpielstand.Caption:='Spielstand:';
   Doppelpunkt.Caption:=':';
   Image.Transparent:=false;
   gestartet:=true;
   ZeichneGitter(Brett);
   ZeichneSteine(F);
  end;

 procedure TReversi.Moeglichkeiten(var F:TSpielFeld;AmZug:TSpieler;var ZL:TSpielZugListe);
  var k:byte;
  begin
   for k:=12 to 89 do
    if F[k]=4 then F[k]:=3;
   for k:=1 to GenZugListe(F,AmZug,ZL) do F[ZL[k-1]]:=4;
   ZeichneSteine(F);
  end;

 function TReversi.Spielende:Boolean;
  var ZL:TSpielZugListe;
  begin
   if (GenZugListe(F,AndererSpieler(AmZug),ZL)=0)and(GenZugListe(F,AmZug,ZL)=0) then
    begin
     if Steine[1]>Steine[2] then
      ShowMessage(Name1+' ist siegreich hervorgegangen!!!')
     else if Steine[2]>Steine[1] then
           ShowMessage(Name2+' ist siegreich hervorgegangen!!!')
          else ShowMessage('Remis!');
     result:=true;
    end
   else result:=false;
  end;

 function TReversi.VorschauZug(F:TSpielFeld;Zug:TSpielZug;Amzug:TSpieler;var VL:TSpielZugListe):byte;
  Const Richtung:Array[1..8] of integer = (-11,-10,-9,-1,1,9,10,11);
  Var Spieler,Gegner,r,weite:byte;
  Begin
       Spieler:=ord(Amzug<>Spieler1)+1;//der spieler, der dran ist
       Gegner:=ord(Amzug=Spieler1)+1;//der spieler, der nicht dran ist
       weite:=0;
       SetLength(VL,0);
       for r:=1 to 8 do
       begin
            while F[Zug+(weite+1)*Richtung[r]]=Gegner do inc(weite);
            if (weite>0)and(F[Zug+(weite+1)*Richtung[r]]=spieler)  then
            begin
                 repeat
                      SetLength(VL,Length(VL)+1);
                      VL[Length(VL)-1]:=Zug+weite*Richtung[r];
                      dec(weite);
                 until weite=0;//alles umdrehen
            end
            else weite:=0;
       end;
       result:=length(vl);
  end;

 procedure TReversi.ZeichneGitter(var Brett:Trect);
  var k:Byte;
  begin
   with Image.Canvas do
    begin
     Pen.Width:=TB;
     Pen.Color:=Farben[5];
     Brett:=Rect(2,2,Image.Width-4,Image.Height-4);
     Brush.color:=Farben[4];
     FillRect(Rect(0,0,Image.Width,Image.Height));
     for k:=1 to 7 do
      begin
       MoveTo(Brett.Left+k*FB+(2*k-1)*TB div 2,Brett.Top);
       LineTo(Brett.Left+k*FB+(2*k-1)*TB div 2,Brett.Bottom);
       MoveTo(Brett.Left,Brett.Top+k*FB+(2*k-1)*TB div 2);
       LineTo(Brett.Right,Brett.Top+k*FB+(2*k-1)*TB div 2);
      end;
    end;
  end;

 function TReversi.CellToRect(Cell:TSpielZug;Brett:TRect;FB,TB:Byte):TRect;
  begin
   Result.Left:=Brett.Left+(Cell mod 10 - 2)*(TB+FB);
   Result.Top:=Brett.Top+(Cell div 10 - 1)*(TB+FB);
   Result.Right:=Result.Left+FB;
   Result.Bottom:=Result.Top+FB;
  end;

 procedure TReversi.ZeichneRand;
  var k:Integer;
      Farbe:TColor;
  begin
   TopImage.Width:=ClientWidth;
   TopImage.Top:=0;
   TopImage.Left:=0;
   BottomImage.Width:=ClientWidth;
   BottomImage.Top:=ClientHeight-26;
   BottomImage.Left:=0;
   for k:=0 to ClientWidth do
    begin
     Farbe:=RGB(Round(255*k/ClientWidth), Round(255*k/ClientWidth), 0);
     with TopImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=2;
       Pen.Style:=psInsideFrame;
       MoveTo(k,0);
       LineTo(k,25);
      end;
     with BottomImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=2;
       Pen.Style:=psInsideFrame;
       MoveTo(ClientWidth-k,0);
       LineTo(ClientWidth-k,25);
      end;
   end;
   LeftImage.Top:=25;
   LeftImage.Left:=0;
   LeftImage.Width:=3;
   LeftImage.Height:=ClientHeight-50;
   RightImage.Top:=25;
   RightImage.Left:=ClientWidth-4;
   RightImage.Width:=3;
   RightImage.Height:=ClientHeight-50;
   for k:=0 to LeftImage.Height do
    begin
     Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
     with LeftImage.Canvas do
      begin
       Pen.Color:=Farbe;
       Pen.Width:=5;
       Pen.Style:=psInsideFrame;
       MoveTo(0,k);
       LineTo(2,k);
      end;
     Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
     with RightImage.Canvas do
     begin
      Pen.Color:=Farbe;
      Pen.Width:=5;
      Pen.Style:=psInsideFrame;
      MoveTo(0,LeftImage.Height-k);
      LineTo(2,LeftImage.Height-k);
     end;
   end;
  end;

 procedure TReversi.ZeichneSteine(F:TSpielFeld);
  var k:byte;
      Farbe:TColor;
      Rect:TRect;
  begin
   Image.Canvas.Pen.Width:=3;
   Farbe:=Farben[1];
   for k:=12 to 89 do
    if F[k] in [1,2,3,4] then
     begin
      if F[k]=1 then Farbe:=Farben[1]
      else if F[k]=2 then Farbe:=Farben[2]
      else if F[k]=3 then Farbe:=Farben[4]
      else if F[k]=4 then
       begin
        if opt1 then Farbe:=Farben[3]
        else Farbe:=Farben[4]
       end;
      with Image.Canvas do
       begin
        Brush.Color:=Farbe;
        Pen.Color:=Farbe;
        Rect:=CellToRect(k,Brett,FB,TB);
        Ellipse(Rect.Left+3,Rect.Top+3,Rect.Right-3,Rect.Bottom-3);
       end;
     end;
  end;

 function TReversi.KoordsToCell(x,y:Integer):TSpielZug;
  begin
   Result:=(x + TB div 2) div (TB+FB)+12+((y + TB div 2) div (TB+FB))*10;
  end;

 procedure TReversi.NeuMouseDown(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
  var Farbe:TColor;
  begin
   Farbe:=clgreen;
   if Sender=Neu then Neu.Font.Color:=Farbe;
   if Sender=Optionen then Optionen.Font.Color:=Farbe;
   if Sender=NWSpiel then NWSpiel.Font.Color:=Farbe;
   if Sender=Regeln then Regeln.Font.Color:=Farbe;
   if Sender=Info then Info.Font.Color:=Farbe;
  end;

 procedure TReversi.NeuMouseUp(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
  var Farbe:TColor;
  begin
   Farbe:=clblack;
   if Sender=Neu then Neu.Font.Color:=Farbe;
   if Sender=Optionen then Optionen.Font.Color:=Farbe;
   if Sender=NWSpiel then NWSpiel.Font.Color:=Farbe;
   if Sender=Regeln then Regeln.Font.Color:=Farbe;
   if Sender=Info then Info.Font.Color:=Farbe;
  end;

 procedure TReversi.ImageMouseMove(Sender: TObject; Shift: TShiftState;X,Y:Integer);
  var AktuellesFeld:byte;
      k:integer;
      VL:TSpielZugListe;
      Rect:TRect;
  begin
   if not opt2 then exit;
   AktuellesFeld:=KoordsToCell(x-Brett.Left,y-Brett.Top);
   if AktuellesFeld=LetztesFeld then exit;
   LetztesFeld:=AktuellesFeld;
   ZeichneSteine(F);
   if F[AktuellesFeld]<>4 then exit;
   for k:=0 to VorschauZug(F,AktuellesFeld,Amzug,VL)-1 do
    begin
     Rect:=CellToRect(VL[k],Brett,FB,TB);
     with Image.Canvas do
      begin
       Pen.Width:=3;
       If Amzug=Spieler1 then
        begin Pen.Color:=Farben[1];brush.color:=Farben[2] end
       else begin Pen.Color:=Farben[2];brush.color:=Farben[1] end;
       Ellipse(Rect.Left+3,Rect.Top+3,Rect.Right-3,Rect.Bottom-3);
      end;
    end;
  end;

 procedure TReversi.ImageMouseUp(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
  var GewaehltesFeld:byte;
      ZL:TSpielZugListe;
      buf:TMove;
  begin
   if not gestartet then
    begin
     MessageDLG('Sie mssen erstmal ein neues Spiel starten',mtInformation,[mbOK],0);
     NeuClick(Sender);
     exit
    end;
   if connected and not shallmove then exit;
   GewaehltesFeld:=KoordsToCell(x-Brett.Left,y-Brett.Top);
   if F[GewaehltesFeld]=4 then
    begin
     MachZug(F,GewaehltesFeld,Amzug,Steine);
     if Connected then
      begin
       buf:=GewaehltesFeld;
       if IsServer then
        ServerSocket.Socket.Connections[0].SendBuf(buf,SizeOf(buf))
       else ClientSocket.Socket.SendBuf(buf,SizeOf(buf));
      end;
     if GenZugListe(F,AndererSpieler(AmZug),ZL)>0 then
      begin
       WechselSpieler(AmZug);
       if Connected then
        begin
         WhiteMoves:=not WhiteMoves;
         ShallMove := not (IsServer xor WhiteMoves); //False;
         UpdateCaption;
        end
      end;
     Moeglichkeiten(F,AmZug,ZL);
     if Spielende then gestartet:=false;
    end 
  end;

 procedure TReversi.UpdateCaption;
  var scolor,smessage,SpielerName:string;
  begin
   if not Connected then
    begin scolor := ''; smessage := 'warte auf Verbindung...' end
   else
    begin
     if AmZug=Spieler1 then SpielerName:=Name1
     else SpielerName:=Name2;
     scolor := ' ('+SpielerName+')';
     if ShallMove then smessage := 'bitte setzen!'
     else smessage := 'wartet auf Zug der Gegenseite...';
    end;
   Label4.Caption := Format('Othello - The Game%s - %s', [scolor, smessage]);
  end;

 procedure TReversi.ServerSocketClientConnect(Sender: TObject;Socket: TCustomWinSocket);
  begin
   Connected := True;
   IsServer := True;
   ShallMove := True; //Server beginnt das Spiel
   UpdateCaption;
  end;

 procedure TReversi.ServerSocketClientDisconnect(Sender: TObject;Socket: TCustomWinSocket);
  begin Connected := False end;

 procedure TReversi.SocketRead(Sender: TObject; Socket: TCustomWinSocket);
  var ZL:TSpielZugListe;
      buf:TMove;
  begin
   Socket.ReceiveBuf(buf,SizeOf(buf));
   MachZug(F,buf,Amzug,Steine);
   if GenZugListe(F,AndererSpieler(AmZug),ZL)>0 then
    begin
     WechselSpieler(AmZug);
     WhiteMoves:=not WhiteMoves;
    end;
   Moeglichkeiten(F,AmZug,ZL);
   if Spielende then gestartet:=false;
   // Der folgende Ausdruck ist wahr, wenn beide
   // Boolean-Variablen den Wert True oder beide
   // den Wert False haben
   ShallMove := not (IsServer xor WhiteMoves);
   UpdateCaption;
  end;

 procedure TReversi.ClientSocketConnect(Sender: TObject;Socket: TCustomWinSocket);
  begin
   Connected := True;
   IsServer := False;
   ShallMove := False;
   UpdateCaption;
  end;

 procedure TReversi.ClientSocketDisconnect(Sender: TObject;Socket: TCustomWinSocket);
  begin Connected := False end;

 procedure TReversi.FormDestroy(Sender: TObject);
  begin
   if Connected then
    begin
     ServerSocket.Close;
     ClientSocket.Close;
    end 
  end;

 procedure TReversi.NWSpielClick(Sender: TObject);
  var Servername:String;
  begin
   if ClientSocket.Active then ClientSocket.Active := False;
   if InputQuery('Verbindung mit Gegenspieler', 'PC-Name:', Servername) then
   if Length(Servername) > 0 then
    with ClientSocket do
     begin
      Host := Servername;
      Active := True;
      Connected := True;
     end;
  end;

end.

