unit SchiffeSetzen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Schiffeversenken, StdCtrls, ExtCtrls;

type
  TMenschSchiffe = class(TForm)
    FeldEingabe: TDrawGrid;
    LabelM: TLabel;
    RArt: TRadioGroup;
    SArt: TRadioGroup;
    Zufall: TButton;
    Buttonfertig: TButton;
    Clear: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    Panel1: TPanel;
    Shape2: TShape;
    Shape1: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape20: TShape;
    Label1: TLabel;
    procedure FeldEingabeDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ZufallClick(Sender: TObject);
    procedure ButtonfertigClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    function SchiffGesetzt(Nr:Byte):Boolean;
    function AlleSchiffeGesetzt:Boolean;
    procedure FeldEingabeSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-Deklarationen }
  public
   Feld:Bereich;
    { Public-Deklarationen }
  end;

var MenschSchiffe: TMenschSchiffe;

implementation

{$R *.DFM}

 procedure TMenschSchiffe.FeldEingabeDrawCell(Sender: TObject; Col,
                             Row: Integer; Rect: TRect; State: TGridDrawState);
  const Ziffer=' 1 2 3 4 5 6 7 8 910';
  var Inhalt:Byte;
  begin
   with FeldEingabe.Canvas do
    begin
     if (Col=0) or (Row=0) then
      begin
       Brush.Color:=clWhite;
       Brush.Style:=bsSolid;
       FillRect(Rect);
       Brush.Style:=bsClear;
       Font.Color:=clBlack;
       Font.Style:=[fsBold];
       if Row=0 then
        if Col>0 then TextOut(Rect.Left+6,Rect.Top+6,Char(Col+64));
       if Col=0 then
        if Row>0 then TextOut(Rect.Left+4,Rect.Top+6,Copy(Ziffer,2*Row-1,2))
      end
     else
      begin
       Inhalt:=Feld[Col,Row];
       Brush.Style:=bsSolid;
       Case Inhalt of
         0 : Begin
              Brush.Color:=clNavy; // Leer
              FillRect(Rect)
             End;
        1..10: Begin
                Brush.Color:=clYellow; // gesetztes Schiff
                FillRect(Rect)
               End;
        Rahmen : Begin
                  Brush.Color:=clRed; // verbotene Zone
                  FillRect(Rect)
                 End;
       End;
      end
    end
  end;

 procedure TMenschSchiffe.ZufallClick(Sender: TObject);
  var Z,S,Schiff:Byte;
      CBox:TCheckBox;
  begin
   FOR Z:=0 TO 11 DO
    FOR S:=0 TO 11 DO
     IF (Z=0) OR (S=0) OR (Z=11) OR (S=11) THEN FELD[Z,S]:=RAND
     ELSE FELD[Z,S]:=0;
   FOR SCHIFF:=1 TO 10 DO
    Begin
     Schiffe.SCHIFFSETZEN(SCHIFF,FELD);
     CBox:=TCheckBox(FindComponent('CheckBox'+IntToStr(Schiff)));
     CBox.Checked:=True;
    End;
   FeldEingabe.RePaint;
  end;

 function TMenschSchiffe.SchiffGesetzt(Nr:Byte):Boolean;
  var Z,S:Byte;
  begin
   FOR Z:=1 TO 10 DO
    FOR S:=1 TO 10 DO
     IF Feld[Z,S]=Nr THEN
      Begin SchiffGesetzt:=True;Exit End;
   SchiffGesetzt:=False;
  end;

 function TMenschSchiffe.AlleSchiffeGesetzt:Boolean;
  var K:Byte;
  begin
   for K:=1 to 10 do
    if Not SchiffGesetzt(K) then
     begin AlleSchiffeGesetzt:=False;exit end;
   AlleSchiffeGesetzt:=True;
  end;

 procedure TMenschSchiffe.ButtonfertigClick(Sender: TObject);
  begin
   if AlleSchiffeGesetzt then close
   else MessageDlg('Du hast NICHT alle Schiffe gesetzt!',mtError,[mbOk],0)
  end;

 procedure TMenschSchiffe.ClearClick(Sender: TObject);
  var K,Z,S:Byte;
      CBox:TCheckBox;
  begin
   FOR Z:=0 TO 11 DO
    FOR S:=0 TO 11 DO
     IF (Z=0) OR (S=0) OR (Z=11) OR (S=11) THEN FELD[Z,S]:=RAND
     ELSE FELD[Z,S]:=0;
   For K:=1 to 10 do
    Begin
     CBox:=TCheckBox(FindComponent('CheckBox'+IntToStr(K)));
     CBox.Checked:=False;
    End;
   FeldEingabe.RePaint;
  end;

 procedure TMenschSchiffe.FeldEingabeSelectCell(Sender: TObject; Col,
                                       Row: Integer; var CanSelect: Boolean);
  var Inhalt,Z,S,K,L,RI,Nr,X_BEREICH,Y_BEREICH,X_START,Y_START:Integer;
      OK:Boolean;
      CBox:TCheckBox;
  begin
   Inhalt:=Feld[Col,Row];
   if Inhalt in[1..10] then
    begin
     CBox:=TCheckBox(FindComponent('CheckBox'+IntToStr(Inhalt)));
     CBox.Checked:=False;
     FOR Z:=1 TO 10 DO  // Schiff mit Rahmen lschen
      FOR S:=1 TO 10 DO
       IF Feld[Z,S]=Inhalt THEN
        begin
         Feld[Z,S]:=0;
         for K:=-1 to 1 do
          for L:=-1 to 1 do
           if Feld[Z+K,S+L]=Rahmen then Feld[Z+K,S+L]:=0;
        end;
     FOR Z:=1 TO 10 DO // Rahmen eventuell restaurieren
      FOR S:=1 TO 10 DO
       IF Feld[Z,S] in[1..10] THEN
        begin
         for K:=-1 to 1 do
          for L:=-1 to 1 do
           if Feld[Z+K,S+L]=0 then Feld[Z+K,S+L]:=Rahmen;
        end;
     FeldEingabe.RePaint;
     exit
    end;
   Nr:=SArt.ItemIndex+1;
   if SchiffGesetzt(Nr) then
    begin
     MessageDlg(SArt.Items[Nr-1]+' hast Du schon gesetzt!',mtError,[mbOk],0);
     exit
    end;
   RI:=RArt.ItemIndex;
   IF RI=0 THEN                        { X=Zeile  Y=Spalte }
    BEGIN Y_BEREICH:=11-SCHIFFLISTE[NR];X_BEREICH:=10 END
   ELSE BEGIN X_BEREICH:=11-SCHIFFLISTE[NR];Y_BEREICH:=10 END;
   X_START:=Col;Y_START:=Row;
   if (Y_START<=Y_BEREICH) AND (X_START<=X_BEREICH) then
    begin
     OK:=TRUE;
     FOR K:=1 TO SCHIFFLISTE[NR] DO
      IF RI=0 THEN OK:=OK AND (FELD[X_START,Y_START+K-1]=0)
      ELSE OK:=OK AND (FELD[X_START+K-1,Y_START]=0);
     if OK then
      begin
       FOR K:=1 TO SCHIFFLISTE[NR] DO
        IF RI=0 THEN FELD[X_START,Y_START+K-1]:=NR
        ELSE FELD[X_START+K-1,Y_START]:=NR;
       Schiffe.BLOCKIEREN(FELD,X_START,Y_START,SCHIFFLISTE[NR],RI);
       FeldEingabe.RePaint;
       CBox:=TCheckBox(FindComponent('CheckBox'+IntToStr(Nr)));
       CBox.Checked:=True;
      end
    end;
  end;

 procedure TMenschSchiffe.FormCloseQuery(Sender:TObject;var CanClose:Boolean);
  begin
   if AlleSchiffeGesetzt then CanClose:=True
   else
    begin
     MessageDlg('Du hast NICHT alle Schiffe gesetzt!',mtError,[mbOk],0);
     CanClose:=False
    end
  end;































end.

